src/Entity/Qualiter.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Validator\Constraints as Assert;


/**
 * @ORM\Entity(repositoryClass="App\Repository\QualiterRepository")
 * @UniqueEntity(fields={"libelle_qualite_fr"},message="Nom qualiter déja existant!!")
 * @UniqueEntity(fields={"libelle_qualite_ar"},message="Nom qualiter déja existant!!")
 */
class Qualiter
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Le libéllé français est obligatoire")
     */
    private $libelle_qualite_fr;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Le libéllé arabe est obligatoire")
     */
    private $libelle_qualite_ar;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Enseignant", mappedBy="qualiter")
     */
    private $enseignants;

    public function __construct()
    {
        $this->enseignants = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLibelleQualiteFr(): ?string
    {
        return $this->libelle_qualite_fr;
    }

    public function setLibelleQualiteFr(string $libelle_qualite_fr): self
    {
        $this->libelle_qualite_fr = $libelle_qualite_fr;

        return $this;
    }

    public function getLibelleQualiteAr(): ?string
    {
        return $this->libelle_qualite_ar;
    }

    public function setLibelleQualiteAr(string $libelle_qualite_ar): self
    {
        $this->libelle_qualite_ar = $libelle_qualite_ar;

        return $this;
    }

    /**
     * @return Collection|Enseignant[]
     */
    public function getEnseignants(): Collection
    {
        return $this->enseignants;
    }

    public function addEnseignant(Enseignant $enseignant): self
    {
        if (!$this->enseignants->contains($enseignant)) {
            $this->enseignants[] = $enseignant;
            $enseignant->setQualiter($this);
        }

        return $this;
    }

    public function removeEnseignant(Enseignant $enseignant): self
    {
        if ($this->enseignants->contains($enseignant)) {
            $this->enseignants->removeElement($enseignant);
            // set the owning side to null (unless already changed)
            if ($enseignant->getQualiter() === $this) {
                $enseignant->setQualiter(null);
            }
        }

        return $this;
    }
    public function __toString(){
        // to show the name of the Category in the select
        return $this->libelle_qualite_ar;
        // to show the id of the Category in the select
        // return $this->id;
    }
}

src/Form/QualiterType.php
<?php

namespace App\Form;

use App\Entity\Qualiter;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class QualiterType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('libelle_qualite_fr',TextType::class,
                array('label' => 'Libelle qualiter en français: ',
                    'required'=>false,
                    'attr' => array('class'=>'form-control')))
            ->add('libelle_qualite_ar',TextType::class,
                array('label' => 'Libelle qualiter en arabe ',
                    'required'=>false,
                    'attr' => array('class'=>'form-control')))
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Qualiter::class,
        ]);
    }
}

src/Controller/QualiterController.php
<?php

namespace App\Controller;

use App\Entity\Qualiter;
use App\Form\QualiterType;
use App\Repository\QualiterRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;

/**
 * @Route("/qualiter")
 * @Security("is_granted('ROLE_ADMIN')")
 */
class QualiterController extends AbstractController
{
    /**
     * @Route("/", name="qualiter_index", methods={"GET","POST"})
     */
    public function index(QualiterRepository $qualiterRepository, Request $request): Response
    {
        $qualiter = new Qualiter();
        $form = $this->createForm(QualiterType::class, $qualiter);
        $form->handleRequest($request);


        return $this->render('qualiter/index.html.twig', [
            'qualiters' => $qualiterRepository->findAll(), 'qualiter' => $qualiter,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/new", name="qualiter_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $qualiter = new Qualiter();
        $form = $this->createForm(QualiterType::class, $qualiter);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($qualiter);
            $entityManager->flush();
            $this->addFlash("info", "Qualiter Ajouter Avec Succés");
            return new Response('ok');
        }

        return $this->render('qualiter/_form.html.twig', [
            'qualiter' => $qualiter,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="qualiter_show", methods={"GET"})
     */
    public function show(Qualiter $qualiter): Response
    {
        return $this->render('qualiter/show.html.twig', [
            'qualiter' => $qualiter,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="qualiter_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Qualiter $qualiter): Response
    {
        $form = $this->createForm(QualiterType::class, $qualiter);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();
            $this->addFlash("info", "Qualiter Modifier Avec Succés");
            return new Response('ok');
        }

        return $this->render('qualiter/_form_edit.html.twig', [
            'qualiter' => $qualiter,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="qualiter_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Qualiter $qualiter): Response
    {
        if ($this->isCsrfTokenValid('delete' . $qualiter->getId(), $request->request->get('_token'))) {
            if ($qualiter->getEnseignants()->count() > 0) {
                $this->addFlash("danger", "Cet Qualiter ne peut pas etre supprimer");
            } else {
                $entityManager = $this->getDoctrine()->getManager();
                $entityManager->remove($qualiter);
                $entityManager->flush();
                $this->addFlash("info", "Qualiter supprimer Avec Succés");
            }
        }
        return $this->redirectToRoute('qualiter_index');
    }
}

templates/qualiter/_delete_form.html.twig
<form method="post" id="form_delete_qualiter_{{ qualiter.id }}" action="{{ path('qualiter_delete', {'id': qualiter.id}) }}" >
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ qualiter.id) }}">
    <button type="button" class="btn btn-danger btn_del_qualiter" id_qualiter="{{ qualiter.id }}" name_qualiter="{{ qualiter.libelleQualiteAr }}" ><span class="glyphicon glyphicon-trash" title="Supprimer qualiter" ></span></button>
</form>

templates/qualiter/_form.html.twig
{% form_theme form 'bootstrap_3_layout.html.twig' %}
<div class="w3-container">
    <div class="card-columns">
        <div class="card ">
            <div class="card-body">
                {{ form_start(form,{'attr':{'id':'form_add_qualiter','action':path('qualiter_new'),'novalidate':'novalidate'} }) }}
                {{ form_widget(form) }}
                <button class="btn btn-primary save_qualiter"
                        type="button">{{ button_label|default('Enregistrer') }}</button>
                {{ form_end(form) }}

            </div>
        </div>
    </div>
</div>

templates/qualiter/_form_edit.html.twig
{% form_theme form 'bootstrap_3_layout.html.twig' %}
<div class="w3-container">
    <div class="card-columns">
        <div class="card ">
            <div class="card-body">
                {{ form_start(form,{'attr':{'id':'form_add_qualiter','action':path('qualiter_edit', {'id': qualiter.id}),'novalidate':'novalidate'} }) }}
                {{ form_widget(form) }}
                <button class="btn btn-primary edit_qualiter" type="button" >{{ button_label|default('Modifier') }}</button>
                {{ form_end(form) }}

            </div>
        </div>
    </div>
</div>

templates/qualiter/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Qualiter{% endblock %}

{% block body %}
<h1></h1>
<!-- Main content -->
<section class="content">
    <div class="row">
        <!-- left column -->
        <div class="col-md-12">
            <!-- general form elements -->
            <div class="box box-primary">
                <div class="box-header with-border">
                    <h3 class="box-title">Modifier Qualiter</h3>
                </div>
                <!-- /.box-header -->
                <!-- form start -->

                <div class="box-body">
                    <div class="form-group">

    {{ include('qualiter/_form.html.twig', {'button_label': 'Modifier'}) }}
                    </div>
                </div>

            </div>
        </div>
    </div>
</section>
    <td> <a href="{{ path('qualiter_index') }}"><button class="btn btn-primary"><span class="glyphicon glyphicon-arrow-left"></span></button></a></td>

{% endblock %}

templates/qualiter/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Qualiter{% endblock %}

{% block body %}
    {% for message in app.flashes('info') %}
        <div class="alert alert-success">{{ message }}</div>
    {% endfor %}
    <td>
        <a>
            <button class="btn btn-success btn_new_qualiter" url="{{ path('qualiter_new') }}"><span
                        class="glyphicon glyphicon-plus" title="Ajouter qualiter"> Ajouter</span></button>
        </a>
    </td>
    <div class="box">
        <div class="box-header">
            <h3 class="box-title">Liste Qualiter </h3>
        </div>
        <!-- /.box-header -->
        <div class="box-body">
            <table id="example2" class="table table-bordered table-striped">
                <thead>
                <tr>

                    <th>Libelle qualite français</th>
                    <th>Libelle qualite arabe</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                {% for qualiter in qualiters %}
                    <tr>

                        <td>{{ qualiter.libelleQualiteFr }}</td>
                        <td>{{ qualiter.libelleQualiteAr }}</td>

                        <td>
                            <ul class="list_act_ens">
                                <li>
                                    <a>
                                        <button class="btn btn-primary btn_info_qualiter"
                                                url="{{ path('qualiter_show', {'id': qualiter.id}) }}"><span
                                                    class="glyphicon glyphicon-info-sign" title="Détail"></span>
                                        </button>
                                    </a>
                                </li>
                                <li>
                                    <a>
                                        <button class="btn btn-success btn_edit_qualiter"
                                                url="{{ path('qualiter_edit', {'id': qualiter.id}) }}"><span
                                                    class="glyphicon glyphicon-pencil" title="Modifier qualiter"></span>
                                        </button>
                                    </a>
                                </li>
                                <li>
                                    {{ include('qualiter/_delete_form.html.twig') }} </li>
                            </ul>
                        </td>
                    </tr>

                {% else %}
                    <tr>
                        <td colspan="4">Pas d'enregistrement</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>

            {#fenetre modale #}

            <div class="modal fade" id="modalQualiter" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
                 aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header text-center">
                            <h4 class="modal-title w-100 font-weight-bold titre_modal_qualiter"></h4>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div class="text-center">
                                <img src="{{ asset('images/loading.svg') }}" class="load_modal_body">
                            </div>
                            <div class="content_modal_body">
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
{% block mesJavascripts %}

    <script>
        $('body').on('click', '.btn_new_qualiter', function (event) {
            $('#modalQualiter').modal('show');
            $('.content_modal_body').html('');
            $('.load_modal_body').show();
            $('.titre_modal_qualiter').html('Ajouter nouvelle qualiter');
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'POST',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_edit_qualiter', function (event) {
            $('#modalQualiter').modal('show');
            $('.content_modal_body').html('');
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            $('.load_modal_body').show();
            $('.titre_modal_qualiter').html('Modifier Qualiter');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'POST',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_info_qualiter', function (event) {
            $('#modalQualiter').modal('show');
            $('.content_modal_body').html('');
            $('.load_modal_body').show();
            $('.modal-footer').html('<button type="button" class="btn btn-danger pull-right" data-dismiss="modal">Fermer</button>');
            $('.titre_modal_qualiter').html('Info Qualiter');
            var url = $(this).attr('url');
            $.ajax({
                url: url,
                method: 'GET',
                success: function (result) {
                    $('.load_modal_body').hide();
                    $('.content_modal_body').html(result);
                }
            });
        });
        $('body').on('click', '.btn_del_qualiter', function (event) {
            var name_qualiter = $(this).attr('name_qualiter');
            var id_qualiter = $(this).attr('id_qualiter');
            $('#modalQualiter').modal('show');
            $('.content_modal_body').html('');

            $('.titre_modal_qualiter').html('Supprimer Qualiter');

            $('.content_modal_body').html('Voulez-vous vraiment supprimer la qualiter: <b>' + name_qualiter + '</b>');
            $('.modal-footer').html('<button type="button" class="btn btn-warning pull-right" data-dismiss="modal">Annuler</button><button type="button" class="btn btn-danger pull-right confirm_delete_qualiter" onclick="confirmer_delete_qualiter(' + id_qualiter + ')" data-dismiss="modal">Confirmer</button>');
        });

        function confirmer_delete_qualiter(id_qualiter) {
            $('#form_delete_qualiter_' + id_qualiter).submit();
        }

        $('body').on('click', '.save_qualiter', function (event) {

            var form = $('#form_add_qualiter');
            var formData = new FormData(document.getElementById("form_add_qualiter"));

            $.ajax({
                type: 'POST',
                cache: false,
                data: formData,
                url: form.attr('action'),
                processData: false,
                contentType: false,

                beforeSend: function (XMLHttpRequest) {
                    $('#form_add_qualiter').attr('disabled', true);
                },

                success: function (msg) {
                    if (msg == 'ok') {
                        $('#modalQualiter').modal('hide');
                        location.reload();
                    } else {
                        $('.content_modal_body').html(msg);
                        //alert('erreur');
                    }
                }
            });

        });
        $('body').on('click', '.edit_qualiter', function (event) {

            var form = $('#form_add_qualiter');
            var formData = new FormData(document.getElementById("form_add_qualiter"));

            $.ajax({
                type: 'POST',
                cache: false,
                data: formData,
                url: form.attr('action'),
                processData: false,
                contentType: false,

                beforeSend: function (XMLHttpRequest) {
                    $('#form_add_qualiter').attr('disabled', true);

                },

                success: function (msg) {
                    if (msg == 'ok') {
                        $('#modalQualiter').modal('hide');
                        location.reload();
                    } else {
                        $('.content_modal_body').html(msg);
                        //alert('erreur');
                    }
                }
            });

        });

        function supprimer_qualiter(name_qualiter) {
            $('#modalQualiter').modal('show');
            $('.content_modal_body').html('');

            $('.titre_modal_qualiter').html('Supprimer Qualiter');

            $('.content_modal_body').html('Voulez-vous vraiment supprimer la qualiter: ' + name_qualiter);
            return false;
        }
    </script>

{% endblock %}

templates/qualiter/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Qualiter{% endblock %}

{% block body %}
    <h1>Create new Qualiter</h1>

    {{ include('qualiter/_form.html.twig') }}

    <a href="{{ path('qualiter_index') }}">back to list</a>
{% endblock %}

templates/qualiter/show.html.twig
<table class="table">
    <tbody>
    <tr>
        <th>Libelle_qualite_fr</th>
        <td>{{ qualiter.libelleQualiteFr }}</td>
    </tr>
    <tr>
        <th>Libelle_qualite_ar</th>
        <td>{{ qualiter.libelleQualiteAr }}</td>
    </tr>
    </tbody>
</table>